    
def loadFasta(filename):

    f = open(filename)
    seqdict = {}
    seqname=""
    seq=""

    for row in f:
        if row[0] == '>':
            if seqname:
                seqdict[seqname] = seq                
            seqname=row.rstrip().split()[0][1:]
            seq=""
        else:
            seq+=row.rstrip()
    if seqname:
        seqdict[seqname] = seq


    f.close()
    return seqdict


def seq4loc(seqdict):
    
    locdict={}

    for seqname,seq in seqdict.items():
        loc = seqname.split(":")[1]
        if locdict.has_key(loc):
            locdict[loc].append(seq)
        else:
            locdict[loc] = [seq]

    return locdict
    

def seqs2freqs(seqs):

    freqdic={}

    for seq in seqs:
        for p in seq:
            if freqdic.has_key(p):
                freqdic[p]+=1
            else:
                freqdic[p]=1

    return freqdic


def printSortedFreqs(freqdic):
    
    sorted=[(freq,p) for (p,freq) in freqdic.items()]
    sorted.sort()
    sorted.reverse()

    print " ".join([str(freq) + ":" + p for (freq,p) in sorted])
 

def composition4localization(filename):

    seqdic = loadFasta(filename)
    locdic = seq4loc(seqdic)
    
    for loc,seqs in locdic.items():
        freqdic = seqs2freqs(seqs)
        print loc
        printSortedFreqs(freqdic)

